{ SMReport Designer

  Copyright (C) 1998/99, written by Shkolnik Mike
  FIDOnet: 2:463/106.14
  E-Mail:  mshkolnik@rs-ukraine.kiev.ua
           mike@woccu.freenet.kiev.ua
           mshkolnik@yahoo.com
  WEB: http://www.geocities.com/SiliconValley/Grid/3989
       http://www.geocities.com/mshkolnik
  tel: 380-/44/-552-10-29

  In this unit I create a TSMRChart component for
  demonstation of technology for custom control creation
  in SMReport Designer.
}
unit SMRChart;

interface

uses
  Windows, Classes, graphics, StdCtrls, Controls,
  DB, SMRBase, DBChart;

const
  {range for custom constants is:
   for lnEnglish - 19000..19999
   for lnRussian - 29000..29999
   for lnUkrainian - 39000..39999
   for lnGerman - 49000..49999
   for lnFrance - 59000..59999
   for lnSpanish - 69000..69999
   for lnItalian - 79000..79999
   for lnPortuguese - 89000..89999
  }
  smrcNewChart = 19010;
  smrcDesignerBtnChart = 19011;

type
  { chart on the band }
  TSMRChart = class(TSMRControl)
  private
    { Private declarations }
    FChart: TCustomDBChart;
  protected
    { Protected declarations }
  public
    { Public declarations }
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    function Draw(ACanvas: TCanvas; var ARect: TRect; intBandHeight: Integer; Flags: Word): Integer; override;
    procedure EditProperties(ShowPrevForm: Boolean); override;
  published
    { Published declarations }
    property Chart: TCustomDBChart read FChart write FChart;
  end;


implementation
{$R *.RES}
uses SMRCnst, SMRUtils, DBEditCh, Forms;

var
  frmChartParent: TForm;

{ TSMRChart }
constructor TSMRChart.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);

  FChart := TCustomDBChart.Create(nil);
  FChart.Parent := frmChartParent;
  FChart.BufferedDisplay := False;
  DisplayName := GetString(FSMReport.GetLanguageShift, smrcNewChart);
end;

destructor TSMRChart.Destroy;
begin
  FChart.Free;

  inherited Destroy;
end;

function TSMRChart.Draw(ACanvas: TCanvas; var ARect: TRect; intBandHeight: Integer; Flags: Word): Integer;
begin
  Result := inherited Draw(ACanvas, ARect, intBandHeight, Flags);

  if (Flags and DT_CALCRECT <> 0) then Exit;

  FChart.DrawToMetaCanvas(ACanvas, ARect);
end;

procedure TSMRChart.EditProperties(ShowPrevForm: Boolean);
begin
  inherited EditProperties(False);

  if ShowPrevForm then
  begin
    FChart.Title.Alignment := Alignment;
    FChart.Title.Font.Assign(Font);
    FChart.Color := BackColor;

    EditDBChart(nil, FChart);

    Alignment := FChart.Title.Alignment;
    Font.Assign(FChart.Title.Font);
    BackColor := FChart.Color;

  end;
end;



initialization
  frmChartParent := TForm.Create(nil);
  RegisterSMRControl(TSMRChart, smrcDesignerBtnChart, '', hInstance);

finalization
  frmChartParent.Free;
  UnRegisterSMRControl(TSMRChart);

end.
