{ SMReport Designer

  Copyright (C) 1998/99, written by Shkolnik Mike
  FIDOnet: 2:463/106.14
  E-Mail:  mshkolnik@rs-ukraine.kiev.ua
           mike@woccu.freenet.kiev.ua
           mshkolnik@yahoo.com
  WEB: http://www.geocities.com/SiliconValley/Grid/3989
       http://www.geocities.com/mshkolnik
  tel: 380-/44/-552-10-29

  In this unit I create a TSMRCheckBox component for
  demonstation of technology for custom control creation
  in SMReport Designer.
}
unit SMRCheck;

interface

uses
  Windows, Classes, graphics, StdCtrls, Controls,
  DB, SMRBase;

const
  {range for custom constants is:
   for lnEnglish - 19000..19999
   for lnRussian - 29000..29999
   for lnUkrainian - 39000..39999
   for lnGerman - 49000..49999
   for lnFrance - 59000..59999
   for lnSpanish - 69000..69999
   for lnItalian - 79000..79999
   for lnPortuguese - 89000..89999
  }
  smrcNewCheckBox = 19001;
  smrcDesignerBtnCheckBox = 19002;

type
  { checkbox on the band }
  TSMRCheckBox = class(TSMRControl)
  private
    FExpression: string;
    FState: TCheckBoxState;

    FCheckWidth: Integer;
    FCheckHeight: Integer;
  protected
    { Protected declarations }
  public
    { Public declarations }
    constructor Create(AOwner: TComponent); override;
    function Draw(ACanvas: TCanvas; var ARect: TRect; intBandHeight: Integer; Flags: Word): Integer; override;
    procedure EditProperties(ShowPrevForm: Boolean); override;
  published
    { Published declarations }
    property State: TCheckBoxState read FState write FState;
    property Expression: string read FExpression write FExpression;
  end;

implementation
{$R *.RES}
uses SMRCnst, SMRUtils, SMRChEd, forms;

{ TSMRCheckBox }
constructor TSMRCheckBox.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);

  DisplayName := GetString(FSMReport.GetLanguageShift, smrcNewCheckBox);

  {define a checkbox width in Windows current settings}
  with TBitmap.Create do
    try
      Handle := LoadBitmap(0, PChar(32759));
      FCheckWidth := Width div 4;
      FCheckHeight := Height div 3;
    finally
      Free;
    end;
end;

function TSMRCheckBox.Draw(ACanvas: TCanvas; var ARect: TRect; intBandHeight: Integer; Flags: Word): Integer;
var DS: TDataSet;
    fld: TField;
    AState: TCheckBoxState;
    DrawState: Integer;
    DrawRect: TRect;
begin
  Result := inherited Draw(ACanvas, ARect, intBandHeight, Flags);

  if (Flags and DT_CALCRECT <> 0) then Exit;

  if (Expression = '') then
    AState := State
  else
  begin
    AState := cbUnChecked;

    DS := GetDSByName(FSMReport.DataSets, GetDSName(Expression));
    if Assigned(DS) then
      try
        fld := DS.FieldByName(GetFieldName(Expression));
        if (fld.DataType = ftBoolean) then
          if fld.IsNull then
            AState := cbGrayed
          else
            if fld.AsBoolean then
              AState := cbChecked;
       except
       end;
  end;

  ACanvas.Brush.Color := BackColor;
  case AState of
    cbChecked: DrawState := DFCS_BUTTONCHECK or DFCS_CHECKED;
    cbUnchecked: DrawState := DFCS_BUTTONCHECK;
    else // cbGrayed
      DrawState := DFCS_BUTTON3STATE or DFCS_CHECKED;
  end;

  case Alignment of
    taRightJustify: begin
                      DrawRect.Left := ARect.Right - FCheckWidth;
                      DrawRect.Right := ARect.Right;
                    end;
    taCenter: begin
                DrawRect.Left := ARect.Left + (ARect.Right - ARect.Left - FCheckWidth) div 2;
                DrawRect.Right := DrawRect.Left + FCheckWidth;
              end;
  else // taLeftJustify
    DrawRect.Left := ARect.Left;
    DrawRect.Right := DrawRect.Left + FCheckWidth;
  end;
  DrawRect.Top := ARect.Top + (ARect.Bottom - ARect.Top - FCheckWidth) div 2;
  DrawRect.Bottom := DrawRect.Top + FCheckHeight;

  DrawFrameControl(ACanvas.Handle, DrawRect, DFC_BUTTON, DrawState);
end;

procedure TSMRCheckBox.EditProperties(ShowPrevForm: Boolean);
begin
  inherited EditProperties(False);

  if ShowPrevForm then
  begin
    with TfrmEditCheck.Create(Application) do
      try
        LangShift := FSMReport.GetLanguageShift;
        FillStringsFromRes;

        FSMReport.AssignDataSets(cbExpression.Items);
        PrintWhen := Self.SMPrintWhen;

        FSMReport.AssignGroups(True, frmPrintWhen.cbGroups.Items);
        if (frmPrintWhen.cbGroups.Items.Count = 0) then
          frmPrintWhen.cbGroupChange.Enabled := False;

        if (Expression = '') then
        begin
          rbValue.Checked := True;
          cbState.ItemIndex := Ord(State)
        end
        else
        begin
          rbField.Checked := True;
          cbExpression.ItemIndex := cbExpression.Items.IndexOf(Expression);
        end;

        rgPosition.ItemIndex := Ord(ObjectPosition);
        cbTransparent.Checked := Transparent;
        memoComment.Lines.Assign(Comments);

        if (ShowModal = mrOk) then
        begin
          Transparent := cbTransparent.Checked;

          if rbValue.Checked then
          begin
            Expression := '';
            State := TCheckBoxState(cbState.ItemIndex);
            DisplayName := cbState.Items[cbState.ItemIndex];
          end
          else
          begin
            Expression := cbExpression.Items[cbExpression.ItemIndex];
            State := cbUnChecked;
            DisplayName := Expression;
          end;

          SMPrintWhen := PrintWhen;

          ObjectPosition := TSMRObjectPosition(rgPosition.ItemIndex);
          Comments.Assign(memoComment.Lines);

          Invalidate;
        end;
      finally
        Free
      end;
  end;
end;


initialization
  RegisterSMRControl(TSMRCheckBox, smrcDesignerBtnCheckBox, '', hInstance);

finalization
  UnRegisterSMRControl(TSMRCheckBox);

end.
